//=============================================================================
// Cursor.cpp
//=============================================================================
#include "Stdinc.h"
#include "Cursor.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CCursor::CCursor(void) : m_nHandle( NULL ), m_nFrameCount( 0 )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CCursor::~CCursor(void)
{
	Delete();
}
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
BOOL CCursor::Create( void )
{
	if ( m_nHandle )
	{
		DeleteGraph( m_nHandle );
		m_nHandle = NULL;
	}

	// J[\ǂݍ
	char szFileName[MAX_PATH];
	sprintf_s( szFileName, sizeof(szFileName), "%s\\%s", GRAPHS_SYSTEM_DATA_DIR , CURSOR_FILE_NAME );
	m_nHandle = LoadGraph( szFileName ) ;
	if ( m_nHandle == DX_FAILED )
	{
		CSysError::Msg("摜ǂݍݎs [%s]", szFileName);
		return FALSE;
	}

	m_nFrameCount = 0;

	return TRUE;
}
//-----------------------------------------------------------------------------
// XV
//-----------------------------------------------------------------------------
void CCursor::FrameMove( void )
{
	m_nFrameCount ++;
}
//-----------------------------------------------------------------------------
// `
//-----------------------------------------------------------------------------
void CCursor::Render( void )
{
	if ( !m_bIsVisible )	return;

	DrawGraphEx( m_nPosX, m_nPosY, m_nHandle, TRUE ) ;
}
//-----------------------------------------------------------------------------
// 폜
//-----------------------------------------------------------------------------
void CCursor::Delete( void )
{
	if ( m_nHandle )
	{
		DeleteGraph( m_nHandle );
		m_nHandle = NULL;
	}

	RemoveAllSelectedPos();
}
//-----------------------------------------------------------------------------
// IJ[\ʒuǉ
//-----------------------------------------------------------------------------
void CCursor::AddSelectedPos( int nX, int nY )
{
	m_nFrameCount = 0;

	POSITION *pPos = new POSITION();
	pPos->nPosX = nX;
	pPos->nPosY = nY;

	m_arySelCurPos.push_back( pPos );
}
//-----------------------------------------------------------------------------
// IJ[\ʒu폜
//-----------------------------------------------------------------------------
void CCursor::RemoveAllSelectedPos( void )
{
	for ( int iCnt = 0; iCnt < (int)m_arySelCurPos.size(); iCnt ++ )
	{
		POSITION *pPos = m_arySelCurPos.at( iCnt );
		delete pPos;
	}
	m_arySelCurPos.clear();
}
//-----------------------------------------------------------------------------
// IJ[\`
//-----------------------------------------------------------------------------
void CCursor::RenderSelectedCursor( void )
{
	if ( !m_bIsVisible )	return;

	if ( m_nFrameCount % 4 <= 1 )	// 42`
		return;

	for ( int iCnt = 0; iCnt < (int)m_arySelCurPos.size(); iCnt ++ )
	{
		POSITION *pPos = m_arySelCurPos.at( iCnt );
		DrawGraphEx( pPos->nPosX, pPos->nPosY, m_nHandle, TRUE ) ;
	}
}
