#include <time.h>
#include "Stdinc.h"
#include "Game.h"
#include "FPSControl.h"

#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>
//-----------------------------------------------------------------------------
// vg^Cv錾
//-----------------------------------------------------------------------------
static BOOL GetVersionString( char *lpVerBuff, int nBufSize );


//-----------------------------------------------------------------------------
// WinMain
//-----------------------------------------------------------------------------
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
						LPSTR lpCmdLine, int nCmdShow )
{
#ifdef _DEBUG
	_CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF ); 
	//_CrtSetBreakAlloc(906);

	AllocConsole();

	FILE *console;
    freopen_s(&console,"CONOUT$","w",stdout);

	printf("program start\n" );
#endif

	// VXe̐ݒ
	SetOutApplicationLogValidFlag( FALSE );		// Oo͂Ȃ
	SetAlwaysRunFlag( TRUE );					// ANeBu̎삷

	// ToDo: ptH[}Xቺ邪
	//       DrawLineg
	SetUse3DFlag( FALSE );						// 3DgȂ
	//SetScreenMemToVramFlag( TRUE );			// SetUse3DFlag:FALSEƃZbg

	// EBhE̐ݒ
	ChangeWindowMode( TRUE );					// Window[h
	//SetWindowStyleMode( 5 ) ;
	//SetWindowSizeExtendRate( 0.5f );
	//SetWindowSizeExtendRate( 1.0f );
	SetWindowSizeExtendRate( 2.0f );
	SetGraphMode(CANVAS_WIDTH, CANVAS_HEIGHT, 32);

	//SetWaitVSyncFlag( FALSE );				// ҂

	// o[W^Cgɐݒ
	char szBuff[64], szVerBuff[64];
	if ( !GetVersionString( szVerBuff, sizeof(szVerBuff) ) )
	{
		CSysError::Halt( "o[Wԍ擾s" );
		return -1;
	}
	sprintf_s( szBuff, "FirstFantasy ver %s", szVerBuff );
	SetMainWindowText( szBuff );

	// DXCu
	if( DxLib_Init() == -1 )
	{
		return -1;
	}
	SetDrawScreen( DX_SCREEN_BACK );			// _uobt@gp


	// tHg̐ݒ
	SetFontSize(DISPLAY_MESSAGE_FONT_SIZE);
	SetFontThickness( 1 );
	SetFontSpace( -1 );
	ChangeFont("lr SVbN");

	// ݒ
	SRand( (int)time(NULL) );

	// `֌W̐ݒ
	//SetMouseDispFlag( FALSE );				// }EX\

	FPSControl FPSC( 10000.0f , 800 ); //tbV[gƕ`Ԋu̎wi͏ȗj
    FPSC.SetDisp( 0 , 0 , GetColor(255,255,255) ); //̕`ʒuƐF̎w

	CGame *pGame = CGame::GetInstance();
	pGame->Initialize();

	// C[v
	while(!ProcessMessage())
	{
		pGame->FrameMove();

		// `
		ClearDrawScreen();
		pGame->Render();

		// Present
		FPSC.All();
		ScreenFlip();
	}

	pGame->Finalize();

	// I
	DxLib_End();

#ifdef _DEBUG
	FreeConsole();
#endif

	return 0;
}

//-----------------------------------------------------------------------------
// GetVersionString
//-----------------------------------------------------------------------------
static BOOL GetVersionString( char *lpVerBuff, int nBufSize )
{
	// 
	strcpy_s( lpVerBuff, nBufSize, "0.0.0.0" );

	DWORD dwLen;
	DWORD dwHandle;

	// o[W񃊃\[X̃TCY擾
	dwLen = ::GetFileVersionInfoSize(__argv[0], &dwHandle);
	if( !dwLen )
		return FALSE;

	// obt@̊m
	char *lpData = new char[dwLen + 1];
	if( !lpData )
		return FALSE;

	// o[W񃊃\[Xobt@ɓǂݍ
	if ( !::GetFileVersionInfo(__argv[0], 0, dwLen, lpData) )
	{
		delete [] lpData;
		return FALSE;
	}

	UINT nLen;
	DWORD *dwLang;
	char lpSubBlock[50] = _T("\\VarFileInfo\\Translation");

	// lang-codepage擾
	if ( !::VerQueryValue(lpData, lpSubBlock, (void **)&dwLang, &nLen) )
	{
		delete [] lpData;
		return FALSE;
}
	// lang-codepagetH[}bg
	char lpLang[9];
	sprintf_s(lpLang, "%04x%04x", LOWORD(*dwLang), HIWORD(*dwLang));

	// 擾
	LPTSTR lpBuffer;
	LPTSTR lpString = _T("ProductVersion"); // io[W
	sprintf_s(lpSubBlock, "\\StringFileInfo\\%s\\%s", lpLang, lpString);
	::VerQueryValue(lpData, lpSubBlock, (void **)&lpBuffer, &nLen);

	strcpy_s( lpVerBuff, nBufSize, lpBuffer );

	delete [] lpData;

	return TRUE;
}

