//=============================================================================
// MapEvent.cpp
//=============================================================================
#include "Stdinc.h"
#include "MapEvent.h"
#include "MapObject.h"
#include "CharacterObject.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CMapEvent::CMapEvent(void)
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CMapEvent::~CMapEvent(void)
{
	Clear();
}

//-----------------------------------------------------------------------------
// Clear
//-----------------------------------------------------------------------------
void CMapEvent::Clear( void )
{
	using namespace std;

	list<CMapObject *>::iterator it = m_lstMapObj.begin();
	int iCnt = 0;
	while( it != m_lstMapObj.end() )
	{
		printf( "Count [%d] : ID [%d] %04X\n", iCnt ++, (*it)->m_nID, (*it) );
		CMapObject *pMapObj = (*it);
		if ( pMapObj )
		{
			delete pMapObj;
			pMapObj = NULL;
		}
		++it;
	}

	delete [] m_wMapObject;
	m_lstMapObj.clear();
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CMapEvent::FrameMove( CMapManager *pMapMan )
{
	using namespace std;
	list<CMapObject *>::iterator it = m_lstMapObj.begin();
	while( it != m_lstMapObj.end() )
	{
		CMapObject *pMapObj = (*it);
		if ( pMapObj )
		{
			pMapObj->FrameMove( pMapMan );
		}
		++it;
	}
}
//-----------------------------------------------------------------------------
// RenderMapObjects
//-----------------------------------------------------------------------------
void CMapEvent::RenderMapObjects( CCharacterObject *pPlayer, int iLeftTopX, int iLeftTopY, int nDrawOffsetX, int nDrawOffsetY )
{
	// v[L
	int nPlayerY = iLeftTopY + SCREEN_CENTER_TILE_Y;
	BOOL bDrawPlayer = FALSE;

	using namespace std;

	list<CMapObject *>::iterator it = m_lstMapObj.begin();
	while( it != m_lstMapObj.end() )
	{
		CMapObject *pMapObj = (*it);

		// ʔ͈͓`FbN
		if ( iLeftTopX - 1 <= pMapObj->GetLocationX() &&
			 pMapObj->GetLocationX() <= iLeftTopX + TILE_COUNT_X+1 &&

			 iLeftTopY - 1 <= pMapObj->GetLocationY() &&
			 pMapObj->GetLocationY() <= iLeftTopY + TILE_COUNT_Y+1 )
		{

			// v[L`FbN
			if ( !bDrawPlayer && nPlayerY < pMapObj->GetLocationY()  )
			{
				pPlayer->Render();
				bDrawPlayer = TRUE;
			}

			int iPosX = (pMapObj->GetLocationX() - iLeftTopX) * MAP_CHIP_SIZE - ( MAP_CHIP_SIZE / 2 );
			int iPosY = (pMapObj->GetLocationY() - iLeftTopY) * MAP_CHIP_SIZE - ( ONE_CHAR_HEIGHT - MAP_CHIP_SIZE ); 

			pMapObj->SetPos( iPosX + nDrawOffsetX, iPosY + nDrawOffsetY );
			pMapObj->Render();
		}
		++it;
	}

	// v[L`FbN
	if ( !bDrawPlayer )
	{
		pPlayer->Render();
	}
}
//-----------------------------------------------------------------------------
// [static] CompObjY
// \[gp
//-----------------------------------------------------------------------------
BOOL CMapEvent::CompObjY( CMapObject* lhs, CMapObject* rhs)
{
	return lhs->GetLocationY() < rhs->GetLocationY();
}
//-----------------------------------------------------------------------------
// SortMapObject
//-----------------------------------------------------------------------------
void CMapEvent::SortMapObject( void )
{
	m_lstMapObj.sort( CompObjY );
}

//-----------------------------------------------------------------------------
// GetMapObject
// LocationW
//-----------------------------------------------------------------------------
CMapObject *CMapEvent::GetMapObject( int nLocX, int nLocY )
{
	using namespace std;

	list<CMapObject *>::iterator it = m_lstMapObj.begin();
	while( it != m_lstMapObj.end() )
	{
		CMapObject *pMapObj = (*it);
		if ( pMapObj->GetLocationX() == nLocX && pMapObj->GetLocationY() == nLocY )
		{
			return pMapObj;
		}
		++it;
	}

	return NULL;
}//-----------------------------------------------------------------------------
// GetMapObject
// ID
//-----------------------------------------------------------------------------
CMapObject *CMapEvent::GetMapObject( int nObjID )
{
	using namespace std;

	list<CMapObject *>::iterator it = m_lstMapObj.begin();
	while( it != m_lstMapObj.end() )
	{
		CMapObject *pMapObj = (*it);
		if ( pMapObj->GetID() == nObjID )
		{
			return pMapObj;
		}
		++it;
	}
	return NULL;
}
