//=============================================================================
// MapObject.cpp
//=============================================================================
#include "Stdinc.h"
#include "MapObject.h"
#include "MapManager.h"
#include "Game.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CMapObject::CMapObject(void)
	: m_lpzLuaFileName( NULL ), m_nNextMoveFrameCnt( 0 )
{
	m_funcpExec = NULL;
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CMapObject::~CMapObject(void)
{
	if ( m_lpzLuaFileName )
	{
		delete [] m_lpzLuaFileName;
		m_lpzLuaFileName = NULL;
	}
}
//-----------------------------------------------------------------------------
// 
// oݒ肪łɂĂO
//-----------------------------------------------------------------------------
BOOL CMapObject::Create( int nLocX, int nLocY )
{
	m_nLocX = nLocX;
	m_nLocY = nLocY;

	BOOL bRet = TRUE;
	bRet &= CCharacterObject::Create( m_nID, m_nPicID );

	// StableIuWFNg̏ꍇ̓Q[tO 󔠃tOŏԂς
	if ( m_nType == MAP_OBJECT_TYPE_STABLE )
	{
		CGame *pGame = CGame::GetInstance();
		if ( pGame->GetTreasureFlag( pGame->GetMapID(), m_nID ) == 0 )
		{	// J
			m_nState = STATE_1;
		}
		else 
		{
			m_nState = STATE_2;
		}
	}

	return bRet;
}
//-----------------------------------------------------------------------------
// XV
//-----------------------------------------------------------------------------
void CMapObject::FrameMove( CMapManager *pMapMan )
{
	// }bvؑփ`FbN
	if ( m_nType == MAP_OBJECT_TYPE_FLOOR && m_nScriptTriger == MAP_SCRIPT_TRIGER_PLAYER_ON )
	{
		// v[L`FbN
		int nX, nY;
		pMapMan->GetCenterPos( &nX, &nY );
		if ( m_nLocX == nX && m_nLocY == nY && !pMapMan->IsScrolling() && !pMapMan->IsScriptExecuting() )
		{
			CGame::GetInstance()->StartScriptRequest( this );
		}
	}

	if ( 0 < m_nMoveFrameCnt )
	{	// ĂƂ
		-- m_nMoveFrameCnt;

		int iNewOffsetX = (int)( MAP_CHIP_SIZE * (double)m_nMoveFrameCnt / m_nStartFrameCnt );
		if ( m_nDrawOffsetX < 0 )
		{
			m_nDrawOffsetX = -iNewOffsetX;
		}
		else if ( 0 < m_nDrawOffsetX )
		{
			m_nDrawOffsetX = iNewOffsetX;
		}
		int iNewOffsetY = (int)( MAP_CHIP_SIZE * (double)m_nMoveFrameCnt / m_nStartFrameCnt );
		if ( m_nDrawOffsetY < 0 )
		{
			m_nDrawOffsetY = -iNewOffsetY;
		}
		else if ( 0 < m_nDrawOffsetY )
		{
			m_nDrawOffsetY = iNewOffsetY;
		}
		// p^[Gݒ
		m_nState = ( (abs(m_nDrawOffsetX) + abs(m_nDrawOffsetY) ) % MAP_CHIP_SIZE) / 4;

		//printf("MoveFrameCnt %d  Offset: (%d,%d)\n", m_nMoveFrameCnt, m_nDrawOffsetX, m_nDrawOffsetY );
		return;
	}

	if ( m_nMoveType == MOVE_TYPE_RANDOM )
	{	// _ړ
		if ( 0 < m_nNextMoveFrameCnt )
		{	// ܂Ȃ
			-- m_nNextMoveFrameCnt;
			return;
		}

		int nDirection = GetRandomMoveDir();
		// ړ`FbN܂ł̑҂Ԑݒ
		m_nNextMoveFrameCnt = GetMoveFreqFrame();
		m_nNextMoveFrameCnt += GetRand( 60 * 1 );	// 1b_

		if ( nDirection == DIRECTION_MAX )
		{
			// printf("Ȃ\n");
			return;	// Ȃ
		}

		// ʍstO`FbN
		int iX, iY;
		pMapMan->GetNewLoc( &iX, &iY, m_nLocX, m_nLocY, nDirection );
		WORD wHitTest = pMapMan->HitTestTile( iX, iY );
		if ( wHitTest == PASS_FLAG_NO_ENTRY ||	// ʍss
			 wHitTest == PASS_FLAG_COUNTER )	// JE^
		{
			// printf("Ȃ To (%d,%d)\n", iX, iY );
			m_nNextMoveFrameCnt = 0;	// s
			return;	// Ȃ
		}
		// ړJn
		// (m_nLocX, m_nLocY)  nDirection֓̕
		StartMove( nDirection, GetMoveSpeedFrame() );
	}
}

//-----------------------------------------------------------------------------
// StartMove
//-----------------------------------------------------------------------------
void CMapObject::StartMove( int nDirection, int nMoveFrame )
{
	int nNewLocX, nNewLocY;

	if ( !CMapManager::GetNewLoc( &nNewLocX, &nNewLocY, m_nLocX, m_nLocY, nDirection ) )
	{	// Ȃ
		return;
	}

	//printf("(%d,%d) -> (%d,%d)\n", m_nLocX, m_nLocY, nNewLocX, nNewLocY );
	// ړݒ
	m_nLocX = nNewLocX;
	m_nLocY = nNewLocY;

	m_nStartFrameCnt = m_nMoveFrameCnt = nMoveFrame;
	m_nDirection = nDirection;

	m_nDrawOffsetX = m_nDrawOffsetY = 0;

	switch ( nDirection )
	{
	case DIRECTION_D:
		m_nDrawOffsetY = -MAP_CHIP_SIZE;
		break;
	case DIRECTION_U:
		m_nDrawOffsetY = MAP_CHIP_SIZE;
		break;
	case DIRECTION_R:
		m_nDrawOffsetX = -MAP_CHIP_SIZE;
		break;
	case DIRECTION_L:
		m_nDrawOffsetX = MAP_CHIP_SIZE;
		break;
	}

}
//-----------------------------------------------------------------------------
// GetRandomMoveDir
//-----------------------------------------------------------------------------
int CMapObject::GetRandomMoveDir( void )
{
	int iDir = GetRand( DIRECTION_MAX );
	return iDir;
}

//-----------------------------------------------------------------------------
// GetMoveFreqFrame
//-----------------------------------------------------------------------------
int CMapObject::GetMoveFreqFrame( void )
{
	switch ( m_nMoveFreq )
	{
	case MOVE_FREQ_LOW:
		return 60 * 4;	// 4b1
	case MOVE_FREQ_NORMAL:
		return 60;		//	1b1
	case MOVE_FREQ_HIGH:
		return 30;		//  30b1
	}

	return 60;
}
//-----------------------------------------------------------------------------
// GetMoveSpeedFrame
//-----------------------------------------------------------------------------
int CMapObject::GetMoveSpeedFrame( void )
{
	switch ( m_nMoveSpeed )
	{
	case MOVE_SPEED_LOW:
		return 32;
	case MOVE_SPEED_NORMAL:
		return 16;
	case MOVE_SPEED_HIGH:
		return 8;
	}

	return 16;
}

//-----------------------------------------------------------------------------
// [static] GetMoveType
//-----------------------------------------------------------------------------
int CMapObject::GetMoveType( const char *pText ) 
{
	if ( !pText )
		return MOVE_TYPE_FIXED;

	if ( !strcmp( pText, "RANDOM" ) )
		return MOVE_TYPE_RANDOM;
	else if ( !strcmp( pText, "RANDOM" ) )
		return MOVE_TYPE_FIXED;

	return MOVE_TYPE_FIXED;
}
//-----------------------------------------------------------------------------
// [static] GetMoveFreq
//-----------------------------------------------------------------------------
int CMapObject::GetMoveFreq( const char *pText )
{
	if ( !pText )
		return MOVE_FREQ_NORMAL;


	if ( !strcmp( pText, "NORMAL" ) )
		return MOVE_FREQ_NORMAL;
	else if ( !strcmp( pText, "HIGH" ) )
		return MOVE_FREQ_HIGH;
	else if ( !strcmp( pText, "LOW" ) )
		return MOVE_FREQ_LOW;

	return MOVE_FREQ_NORMAL;
}
//-----------------------------------------------------------------------------
// [static] GetMoveSpeed
//-----------------------------------------------------------------------------
int CMapObject::GetMoveSpeed( const char *pText )
{
	if ( !pText )
		return MOVE_SPEED_NORMAL;

	if ( !strcmp( pText, "NORMAL" ) )
		return MOVE_SPEED_NORMAL;
	else if ( !strcmp( pText, "HIGH" ) )
		return MOVE_SPEED_HIGH;
	else if ( !strcmp( pText, "LOW" ) )
		return MOVE_SPEED_LOW;

	return MOVE_SPEED_NORMAL;
}
//-----------------------------------------------------------------------------
// [static] GetType
//-----------------------------------------------------------------------------
int CMapObject::GetType( const char *pText ) 
{
	if ( !pText )
		return MAP_OBJECT_TYPE_NPC;

	if ( !strcmp( pText, "NPC" ) )
		return MAP_OBJECT_TYPE_NPC;
	else if ( !strcmp( pText, "STORE" ) )
		return MAP_OBJECT_TYPE_STORE;
	else if ( !strcmp( pText, "FLOOR" ) )
		return MAP_OBJECT_TYPE_FLOOR;
	else if ( !strcmp( pText, "STABLE" ) )
		return MAP_OBJECT_TYPE_STABLE;

	return MAP_OBJECT_TYPE_NPC;
}
//-----------------------------------------------------------------------------
// [static] GetScriptTriger
//-----------------------------------------------------------------------------
int CMapObject::GetScriptTriger( const char *pText )
{
	if ( !pText )
		return MAP_SCRIPT_TRIGER_NONE;

	if ( !strcmp( pText, "BUTTON" ) )
		return MAP_SCRIPT_TRIGER_BUTTON;
	else if ( !strcmp( pText, "ADJOINING" ) )
		return MAP_SCRIPT_TRIGER_ADJOINING;
	else if ( !strcmp( pText, "PLAYER_ON" ) )
		return MAP_SCRIPT_TRIGER_PLAYER_ON;

	return MAP_SCRIPT_TRIGER_NONE;
}
//-----------------------------------------------------------------------------
// [static] GetAniSpeed
//-----------------------------------------------------------------------------
int CMapObject::GetAniSpeed( const char *pText )
{
	if ( !pText )
		return ANI_SPEED_NORMAL;

	if ( !strcmp( pText, "NORMAL" ) )
		return ANI_SPEED_NORMAL;
	else if ( !strcmp( pText, "HIGH" ) )
		return ANI_SPEED_HIGH;
	else if ( !strcmp( pText, "LOW" ) )
		return ANI_SPEED_LOW;

	return ANI_SPEED_NORMAL;
}