//=============================================================================
// MsgWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "MsgWindow.h"
#include "Manipulator.h"
#include "ScriptManager.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CMsgWindow::CMsgWindow(void)
	:m_bWaitNext ( FALSE ), m_nLineCnt( 0 )
{
	RtlZeroMemory( m_szMsg, sizeof(m_szMsg) );
	RtlZeroMemory( m_szDisplayMsg, sizeof(m_szDisplayMsg) );
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CMsgWindow::~CMsgWindow(void)
{
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CMsgWindow::Render( void )
{
	if ( !m_bIsVisible )
		return ;

	CFrameWindow::Render();

	// \
	for ( int iCnt = 0; iCnt < DISPLAY_MESSAGE_LINE_MAX; iCnt ++ )
	{
		int iPosY = m_nPosY + FRAME_TO_STRING_MARGINE_Y + ( iCnt * (DISPLAY_MESSAGE_FONT_SIZE + 4) );

		DrawString( m_nPosX + FRAME_TO_STRING_MARGINE_X, iPosY, m_szDisplayMsg[iCnt], STRING_COLOR );
	}
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CMsgWindow::FrameMove( const CManipulator *pMani, CScriptManager *pScrMan /*= NULL*/ )
{
	CFrameWindow::FrameMove();

	if ( !m_bIsVisible )
		return;

	if ( pMani->CheckKey( KEY_INPUT_X ) || pMani->CheckKey( KEY_INPUT_Z ) )
	{
		m_bWaitNext = TRUE;
	}
}
//-----------------------------------------------------------------------------
// ShowWindow
//-----------------------------------------------------------------------------
void CMsgWindow::ShowWindow( BOOL bFlag )
{
	CFrameWindow::ShowWindow( bFlag );
}

//-----------------------------------------------------------------------------
// SetMessage
// ToDo Âo
//-----------------------------------------------------------------------------
void CMsgWindow::SetMessage( const char *pMsg )
{
	if ( !pMsg )
		return;

	m_bWaitNext = FALSE;

	// bZ[Wۑobt@ɃRs[
	m_nLineCnt = DivCopyToMsgBuf( pMsg );

	// \obt@ɃRs[
	for ( int iCnt = 0; iCnt < DISPLAY_MESSAGE_LINE_MAX; iCnt ++ )
	{
		strcpy_s( m_szDisplayMsg[iCnt], _countof(m_szDisplayMsg[iCnt]), m_szMsg[iCnt] );
	}
}
//-----------------------------------------------------------------------------
// AddMessage
// ToDo Âo
//-----------------------------------------------------------------------------
void CMsgWindow::AddMessage( const char *pMsg )
{
	if ( !pMsg )
		return;

	m_bWaitNext = FALSE;

	// bZ[Wۑobt@ɃRs[
	m_nLineCnt = DivCopyToMsgBuf( pMsg, m_nLineCnt );

	// \obt@ɃRs[
	for ( int iCnt = 0; iCnt < DISPLAY_MESSAGE_LINE_MAX; iCnt ++ )
	{
		strcpy_s( m_szDisplayMsg[iCnt], _countof(m_szDisplayMsg[iCnt]), m_szMsg[iCnt] );
	}
}

//-----------------------------------------------------------------------------
// CopyWidthLimitString
//-----------------------------------------------------------------------------
int CMsgWindow::CopyWidthLimitString( char *pDst, const char *pSrc, int nLen )
{
	strncpy_s( pDst, nLen, pSrc, nLen );

	int iStrLen = strlen(pDst);
	for ( int iCnt = iStrLen; 0 < iCnt; iCnt -- )
	{
		int iStrWidth = GetDrawStringWidth( pDst, iStrLen );
		if ( m_nWidth < iStrWidth + FRAME_TO_STRING_MARGINE_X * 2 )
		{	// Eɂ͂ݏoȂ1
			pDst[iCnt] = '\0';
		}
	}

	return 0;
}
//-----------------------------------------------------------------------------
// DivCopyToMsgBuf
//-----------------------------------------------------------------------------
int CMsgWindow::DivCopyToMsgBuf( const char *pSrc, int nLineCnt /* = 0 */ )
{
	if ( nLineCnt == 0 )
	{
		RtlZeroMemory( m_szMsg, sizeof(m_szMsg) );
	}

	// '\' + 'n' ̕ '\n' ɒu
	char szReplaceBuff[1024];
	CUtil::ReplaceString( szReplaceBuff, sizeof(szReplaceBuff), pSrc, "\\n", "\n" );

//	int nLineCnt = 0;
	const char *pStart = szReplaceBuff;
	const char *pPtr = strstr( szReplaceBuff, "\n" );

	while ( pPtr )
	{
		char szBuff[DISPLAY_MESSAGE_LEN_MAX];
		strncpy_s( szBuff, pStart, (size_t)(pPtr - pStart) );

		CopyWidthLimitString( m_szMsg[nLineCnt], szBuff, _countof(m_szMsg[nLineCnt])-1 );

		nLineCnt++;
		pStart = pPtr+1;
		pPtr = strstr( pPtr+1, "\n" );
	}

	CopyWidthLimitString( m_szMsg[nLineCnt], pStart, _countof(m_szMsg[nLineCnt])-1 );

	return nLineCnt+1;
}