//=============================================================================
// PlayerParty.cpp
//=============================================================================
#include "Stdinc.h"
#include "PlayerParty.h"
#include "DataManager.h"
#include "Item.h"
#include "Game.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CPlayerParty::CPlayerParty(void)
: m_bIsDash( FALSE )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CPlayerParty::~CPlayerParty(void)
{
	RemoveAllItems();
	RemoveAllPlayers();
}
//-----------------------------------------------------------------------------
// RemoveAllItems
//-----------------------------------------------------------------------------
void CPlayerParty::RemoveAllItems( void )
{
	using namespace std;

	vector<stItemInfo *>::iterator it = m_lstItemInfo.begin();
	while( it != m_lstItemInfo.end() )
	{
		if ( !(*it) )
		{
			++it;
			continue;
			}

		delete (*it)->pItem;
		(*it)->pItem = NULL;
		delete (*it);
		(*it) = NULL;

		++it;
	}

	m_lstItemInfo.clear();
}

//-----------------------------------------------------------------------------
// GetScrollSpeed
//-----------------------------------------------------------------------------
int CPlayerParty::GetScrollSpeed( void )
{
	if ( m_bIsDash )
		return SCROLL_SPEED_DASH;

	return SCROLL_SPEED_WALK;
}

//-----------------------------------------------------------------------------
// Initialize
//-----------------------------------------------------------------------------
BOOL CPlayerParty::Initialize( void )
{
	// ToDo : 1l͍
	AddPlayer( 1, 1 );

	// ACeێݒ
	m_lstItemInfo.resize( MAX_ITEM_LIST_COUNT );

	return TRUE;
}
//-----------------------------------------------------------------------------
// XV
//-----------------------------------------------------------------------------
void CPlayerParty::FrameMove( const CManipulator *pMani, CMapManager *pMapMan  )
{
	if ( CGame::GetInstance()->GetMode() == MODE_BATTLE )
	{	// 퓬
	}
	else
	{
		// ݕ\̃L̂ݍXV
		m_aryPlayer.at(CURRENT_DISP)->FrameMove( pMani, pMapMan );
	}
}
//-----------------------------------------------------------------------------
// L[`FbNȂXV
//-----------------------------------------------------------------------------
void CPlayerParty::FrameMove( CMapManager *pMapMan  )
{
	if ( CGame::GetInstance()->GetMode() == MODE_BATTLE )
	{	// 퓬
	}
	else
	{
		// ݕ\̃L̂ݍXV
		m_aryPlayer.at(CURRENT_DISP)->FrameMove( pMapMan );
	}
}
//-----------------------------------------------------------------------------
// `
//-----------------------------------------------------------------------------
void CPlayerParty::Render( void  )
{
	if ( CGame::GetInstance()->GetMode() == MODE_BATTLE )
	{	// 퓬
	}
	else
	{
		// ݕ\̃L̂ݕ`
		m_aryPlayer.at(CURRENT_DISP)->Render();
	}
}
//-----------------------------------------------------------------------------
// wʒuɗG`
//-----------------------------------------------------------------------------
void CPlayerParty::RenderPortrait( int iIndex, int nPosX, int nPosY )
{
	m_aryPlayerBtl.at( iIndex )->RenderPortrait( nPosX, nPosY );
}
//-----------------------------------------------------------------------------
// wʒuɗG`
//-----------------------------------------------------------------------------
void CPlayerParty::RenderPortrait( int iIndex, int nPosX, int nPosY, int nState )
{
	m_aryPlayerBtl.at( iIndex )->RenderPortrait( nPosX, nPosY, nState );
}
//-----------------------------------------------------------------------------
// AddPlayer
//-----------------------------------------------------------------------------
int CPlayerParty::AddPlayer( int nID, int nPicID )
{
	// VKɏ쐬Ēǉ
	CPlayerChar *pPlayer = new CPlayerChar();

	if ( !pPlayer->Create( nID, nPicID, this ) )
	{
		delete pPlayer;
		return m_aryPlayer.size();
	}
	m_aryPlayer.push_back( pPlayer );

	// 퓬pǉ
	CPlayerBattle *pPlayerBtl = new CPlayerBattle();
	pPlayerBtl->Create( nID, nPicID );
	m_aryPlayerBtl.push_back( pPlayerBtl );

	return m_aryPlayer.size();
}
//-----------------------------------------------------------------------------
// RemovePlayer
//-----------------------------------------------------------------------------
int CPlayerParty::RemovePlayer( int nID )
{
	using namespace std;

	// MAPp
	vector<CPlayerChar *>::iterator it = m_aryPlayer.begin();
	while( it != m_aryPlayer.end() )
	{
		if ( (*it)->GetID() == nID)
		{
			delete (*it);
			m_aryPlayer.erase( it );
			return m_aryPlayer.size();
		}
		++it;
	}

	// 퓬p
	vector<CPlayerBattle *>::iterator it2 = m_aryPlayerBtl.begin();
	while( it2 != m_aryPlayerBtl.end() )
	{
		if ( (*it2)->GetID() == nID)
		{
			delete (*it2);
			m_aryPlayerBtl.erase( it2 );
			return m_aryPlayerBtl.size();
		}
		++it2;
	}

	return m_aryPlayer.size();

}
//-----------------------------------------------------------------------------
// SwapPlayer
// ύX
//-----------------------------------------------------------------------------
void CPlayerParty::SwapPlayer( int nLhsID, int nRhsID )
{
	// MAPp
	CPlayerChar *pPlayerLhs = m_aryPlayer.at( nLhsID );
	CPlayerChar *pPlayerRhs = m_aryPlayer.at( nRhsID );

	m_aryPlayer.at(nLhsID) = pPlayerRhs;
	m_aryPlayer.at(nRhsID) = pPlayerLhs;

	// 퓬p
	CPlayerBattle *pPlayerBtlLhs = m_aryPlayerBtl.at( nLhsID );
	CPlayerBattle *pPlayerBtlRhs = m_aryPlayerBtl.at( nRhsID );

	m_aryPlayerBtl.at(nLhsID) = pPlayerBtlRhs;
	m_aryPlayerBtl.at(nRhsID) = pPlayerBtlLhs;
}

//-----------------------------------------------------------------------------
// RemoveAllPlayers
//-----------------------------------------------------------------------------
void CPlayerParty::RemoveAllPlayers( void )
{
	using namespace std;
	vector<CPlayerChar *>::iterator it = m_aryPlayer.begin();
	while( it != m_aryPlayer.end() )
	{
		delete (*it);
		++it;
	}
	// 퓬p
	vector<CPlayerBattle *>::iterator it2 = m_aryPlayerBtl.begin();
	while( it2 != m_aryPlayerBtl.end() )
	{
		delete (*it2);
		++it2;
	}

	m_aryPlayer.clear();
	m_aryPlayerBtl.clear();
}
//-----------------------------------------------------------------------------
// wǉ
//-----------------------------------------------------------------------------
int CPlayerParty::AddItem( int nItemID, int nCount )
{
	// ID̃ACeT
	stItemInfo *pItemInfo = GetItemInfoFromItemID( nItemID );
	if ( pItemInfo )
	{	// ACe
		pItemInfo->nCount += nCount;
		if ( 99 < pItemInfo->nCount )
			pItemInfo->nCount = 99;

	}
	else
	{	// ACe͂Ȃ

		// VKɏ쐬ăXgɒǉ
		pItemInfo = new stItemInfo;
		pItemInfo->nCount = nCount;
		if ( 99 < pItemInfo->nCount )
			pItemInfo->nCount = 99;

		// f[^ǂݍ
		CDataManager::GetInstance()->LoadOneItemData( nItemID, &pItemInfo->pItem );

		// ԏ NULL̂Ƃɐݒ
		std::vector<stItemInfo *>::iterator it = m_lstItemInfo.begin();
		while( it != m_lstItemInfo.end() )
		{
			if ( !(*it) )
			{
				(*it) = pItemInfo;
				break;
			}
			++it;
		}
		if ( it == m_lstItemInfo.end() )
		{	assert( 0 );	}

		//m_lstItemInfo.push_back( pItemInfo );
	}

	printf("[%s]ǉ\n", pItemInfo->pItem->szName );

	return m_lstItemInfo.size();
}
//-----------------------------------------------------------------------------
// AddItem
//-----------------------------------------------------------------------------
int CPlayerParty::AddItem( int nItemID )
{
	return AddItem( nItemID, 1 );
}
//-----------------------------------------------------------------------------
// GetItemInfoFromItemID
// ItemIDŒT
//-----------------------------------------------------------------------------
stItemInfo *CPlayerParty::GetItemInfoFromItemID( int nItemID )
{
	using namespace std;

	vector<stItemInfo *>::iterator it = m_lstItemInfo.begin();
	while( it != m_lstItemInfo.end() )
	{
		if ( (*it) && (*it)->pItem->nID == nItemID)
			return (*it);

		++it;
	}
	return NULL;
}
//-----------------------------------------------------------------------------
// GetItemInfo
// IndexŒT
//-----------------------------------------------------------------------------
stItemInfo *CPlayerParty::GetItemInfo( int nIndex )
{
	if ( (int)m_lstItemInfo.size() <= nIndex )
		return NULL;

	return m_lstItemInfo.at( nIndex );
}
//-----------------------------------------------------------------------------
// RemoveItem
//-----------------------------------------------------------------------------
int CPlayerParty::RemoveItem( int nItemID, int nCount )
{
	using namespace std;

	vector<stItemInfo *>::iterator it = m_lstItemInfo.begin();
	while( it != m_lstItemInfo.end() )
	{
		if ( (*it) && (*it)->pItem->nID == nItemID)
		{
			printf("[%s]폜\n", (*it)->pItem->szName );

			if ( 0 < (*it)->nCount )
			{	// w萔 炷
				(*it)->nCount -= nCount;
			}

			if ( (*it)->nCount <= 0 )
			{
				delete (*it)->pItem;
				(*it)->pItem = NULL;
				delete (*it);
				(*it) = NULL;

				//m_lstItemInfo.erase( it );

			}

			return m_lstItemInfo.size(); 
		}

		++it;
	}
	return m_lstItemInfo.size();
}
//-----------------------------------------------------------------------------
// RemoveItem
//-----------------------------------------------------------------------------
int CPlayerParty::RemoveItem( int nItemID )
{
	return RemoveItem( nItemID, 1 );
}
//-----------------------------------------------------------------------------
// SwapItem
//-----------------------------------------------------------------------------
void CPlayerParty::SwapItem( int nLhsIndex, int nRhsIndex )
{
	stItemInfo *pItemLhs = m_lstItemInfo.at( nLhsIndex );
	stItemInfo *pItemRhs = m_lstItemInfo.at( nRhsIndex );

	m_lstItemInfo.at(nLhsIndex) = pItemRhs;
	m_lstItemInfo.at(nRhsIndex) = pItemLhs;
}
#include <algorithm>
static BOOL ItemIDCompFunc( const stItemInfo *pItemLhs, const stItemInfo *pItemRhs )
{
	if ( !pItemLhs )
		return FALSE;

	if ( !pItemRhs )
		return TRUE;

	return pItemLhs->pItem->nID < pItemRhs->pItem->nID;

}
//-----------------------------------------------------------------------------
// SortItem
//-----------------------------------------------------------------------------
void CPlayerParty::SortItem( void )
{
	std::sort( m_lstItemInfo.begin(), m_lstItemInfo.end(), ItemIDCompFunc );
}
//-----------------------------------------------------------------------------
// GetItemCount
//-----------------------------------------------------------------------------
int CPlayerParty::GetItemCount( int nItemID )
{
	stItemInfo *pInfo = GetItemInfoFromItemID( nItemID );
	if ( !pInfo )
		return 0;

	return pInfo->nCount;

}
//-----------------------------------------------------------------------------
// GetItemKindCount
//-----------------------------------------------------------------------------
int CPlayerParty::GetItemKindCount( void ) const
{
	return m_lstItemInfo.size();
}
//-----------------------------------------------------------------------------
// GetEquipCount
//-----------------------------------------------------------------------------
int CPlayerParty::GetEquipCount( int nItemID )
{
	int nEquipCount = 0;

	using namespace std;
	vector<CPlayerChar *>::iterator it = m_aryPlayer.begin();
	while( it != m_aryPlayer.end() )
	{
		for ( int iCnt = 0; iCnt < CHR_POS_MAX; iCnt ++ )
		{
			if ( (*it)->m_Equip[iCnt].nID == nItemID )
			{
				nEquipCount ++;
			}
		}
		++it;
	}

	return nEquipCount;
}
//-----------------------------------------------------------------------------
// GetEquipableItemList
//-----------------------------------------------------------------------------
int CPlayerParty::GetEquipableItemList( int nJobID, int nCharPos, std::vector<stItemInfo *> &lstItem )
{
	using namespace std;

	// 
	lstItem.clear();

	vector<stItemInfo *>::iterator it = m_lstItemInfo.begin();
	while( it != m_lstItemInfo.end() )
	{
		stItemInfo *pInfo = (*it);
		if ( !pInfo || !CEquipItem::IsEquipItem( pInfo->pItem->nID ) )
		{
			++it;
			continue;
		}

		CEquipItem *pEquip = (CEquipItem *)pInfo->pItem;

		// ʒu`FbN
		if ( !CEquipItem::CanEquipPos( nCharPos, pEquip->nEquipPos ) )
		{
			++it;
			continue;
		}

		// \`FbN
		if ( !CEquipItem::CanEquip( pEquip->nType, nJobID ) )
		{
			++it;
			continue;
		}

		// ǉ
		lstItem.push_back( pInfo );

		++it;
	}

	return lstItem.size();
}
