//=============================================================================
// ScriptManager.h
//=============================================================================
#pragma once
#include <list>
#include "lua.h"

class CMapObject;
class CMapEvent;
//-----------------------------------------------------------------------------
// CScriptManager
//-----------------------------------------------------------------------------
class CScriptManager
{
protected:

	lua_State	*m_LuaState;
	lua_State	*m_LuaCoRoutine;
	CMapObject *m_pTgtMapObj;

	BOOL		m_bExecuting;

	void ClearLuaObject( void );

public:
	CScriptManager(void);
	virtual ~CScriptManager(void);

	BOOL IsExecuting( void ) const
	{	return m_bExecuting;	};

	// XNvg[h
	BOOL Load( int nMapNo, CMapEvent *pMapEvent );

	// }bvIuWFNgXNvgX^[g
	BOOL InitProc( void );
	BOOL Start( CMapObject *pMapObj );
	BOOL ExecNext( void );
	
	CMapObject *GetTargetMapObject( void )
	{	return m_pTgtMapObj;	};
};

// ============================================================================
//  LuaR[obN
// ============================================================================
extern int lua_ShowMessage(lua_State *L);
extern int lua_CloseMessage( lua_State *L );
extern int lua_AddMessage( lua_State *L );
extern int lua_StartFadeout( lua_State *L );
extern int lua_StartFadein( lua_State *L );
extern int lua_ChangeMap( lua_State *L );
extern int lua_Shake( lua_State *L );
extern int lua_GetTreasureFlag( lua_State *L );
extern int lua_GetTreasure( lua_State *L );
extern int lua_MovePlayer( lua_State *L );
extern int lua_MoveMapObject( lua_State *L );
extern int lua_WaitFrame( lua_State *L );
extern int lua_OpenStore( lua_State *L );
