//=============================================================================
// StatusCommandWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "StatusParamWindow.h"
#include "PlayerParty.h"
#include "StatusWindow.h"
#include "DataManager.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CStatusParamWindow::CStatusParamWindow(void)
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CStatusParamWindow::~CStatusParamWindow(void)
{
}
//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CStatusParamWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CPlayerParty *pPlayerParty, CStatusWindow *pParent )
{
	m_pPlayerParty = pPlayerParty;
	m_pParent = pParent;

	BOOL bRet = CFrameWindow::Create( iPosX, iPosY, iWidth, iHeight );

	return bRet;
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CStatusParamWindow::Render( void )
{
	if ( !IsVisible() )
		return;

	CFrameWindow::Render();

	const int BASE_X1 = 40;

	CPlayerChar *pPlayer = m_pPlayerParty->GetPlayer( m_pParent->GetSelectedPlayerIndex() );
	CDataManager *pDataMan = CDataManager::GetInstance();
	// LG
	m_pPlayerParty->RenderPortrait( m_pParent->GetSelectedPlayerIndex(), 6, 10 );

	// O
	const char *lpzText;
	char szBuff[64];
	lpzText = pPlayer->m_CharInfo.szName;
	if ( strlen(lpzText) == 0 )
		lpzText = "?";
	DrawString( BASE_X1, 10, lpzText, STRING_COLOR );

	// Wu
	sprintf_s( szBuff, "%s F %d" ,pDataMan->GetJobName( pPlayer->m_CharInfo.nJobID ), pPlayer->m_CharInfo.nJLV );	lpzText = szBuff;
	DrawString( 140, 10, lpzText, STRING_COLOR );

	// x
	sprintf_s( szBuff, "ku@@@@  %4d" ,pPlayer->m_CharInfo.nLV );	lpzText = szBuff;
	DrawString( BASE_X1, 25, lpzText, STRING_COLOR );
	// HP
	sprintf_s( szBuff, "go@%4d ^ %4d" ,pPlayer->m_CharInfo.nHP, pPlayer->m_BasePram.nMaxHP );	lpzText = szBuff;
	DrawString( BASE_X1, 40, lpzText, STRING_COLOR );
	// MP
	sprintf_s( szBuff, "lo@%4d ^ %4d" ,pPlayer->m_CharInfo.nMP, pPlayer->m_BasePram.nMaxMP );	lpzText = szBuff;
	DrawString( BASE_X1, 55, lpzText, STRING_COLOR );
	// ol
	sprintf_s( szBuff, "񂿁@@@@%8d" ,pPlayer->m_CharInfo.nExp );	lpzText = szBuff;
	DrawString( BASE_X1, 70, lpzText, STRING_COLOR );
	// Lv
	sprintf_s( szBuff, "Lv܂Ł@@@%8d" , pDataMan->GetToNextLvCSV( pPlayer->GetID(), pPlayer->m_CharInfo.nLV, pPlayer->m_CharInfo.nExp ) ); lpzText = szBuff;
	DrawString( BASE_X1, 85, lpzText, STRING_COLOR );

	const int BASE_Y1 = 120;
	// 
	sprintf_s( szBuff, "@@@@%3d" ,pPlayer->m_Param.nAttack );	lpzText = szBuff;
	DrawString( BASE_X1, BASE_Y1 +  0, lpzText, STRING_COLOR );
	// ڂ
	sprintf_s( szBuff, "ڂ@@@@%3d" ,pPlayer->m_Param.nDefence );	lpzText = szBuff;
	DrawString( BASE_X1, BASE_Y1 + 15, lpzText, STRING_COLOR );
	// ܂قڂ
	sprintf_s( szBuff, "܂قڂ@%3d" ,pPlayer->m_Param.nMagicDef );	lpzText = szBuff;
	DrawString( BASE_X1, BASE_Y1 + 30, lpzText, STRING_COLOR );
	// Ђ
	sprintf_s( szBuff, "Ђ@@@%3d" ,pPlayer->m_Param.nParry );	lpzText = szBuff;
	DrawString( BASE_X1, BASE_Y1 + 45, lpzText, STRING_COLOR );
	// ܂ق
	sprintf_s( szBuff, "܂قЁ@@%3d" ,pPlayer->m_Param.nMagicPar );	lpzText = szBuff;
	DrawString( BASE_X1, BASE_Y1 + 60, lpzText, STRING_COLOR );
	// т̂
	sprintf_s( szBuff, "т̂@%3d" ,pPlayer->m_Param.nWeight );	lpzText = szBuff;
	DrawString( BASE_X1, BASE_Y1 + 75, lpzText, STRING_COLOR );


	const int BASE_X2 = 190;
	// 
	sprintf_s( szBuff, "@@@@%3d" ,pPlayer->m_BasePram.nStrength );	lpzText = szBuff;
	DrawString( BASE_X2, BASE_Y1 +  0, lpzText, STRING_COLOR );
	// 傭
	sprintf_s( szBuff, "傭@@%3d" ,pPlayer->m_BasePram.nVitality );	lpzText = szBuff;
	DrawString( BASE_X2, BASE_Y1 + 15, lpzText, STRING_COLOR );
	// ΂₳
	sprintf_s( szBuff, "΂₳@@@%3d" ,pPlayer->m_BasePram.nSpeed );	lpzText = szBuff;
	DrawString( BASE_X2, BASE_Y1 + 30, lpzText, STRING_COLOR );
	// ܂傭
	sprintf_s( szBuff, "܂傭@@@%3d" ,pPlayer->m_BasePram.nIntellect );	lpzText = szBuff;
	DrawString( BASE_X2, BASE_Y1 + 45, lpzText, STRING_COLOR );
	// 
	sprintf_s( szBuff, "@@@%3d" ,pPlayer->m_BasePram.nPiety );	lpzText = szBuff;
	DrawString( BASE_X2, BASE_Y1 + 60, lpzText, STRING_COLOR );
	// 
	sprintf_s( szBuff, "@@@@@%3d" ,pPlayer->m_BasePram.nLuck );	lpzText = szBuff;
	DrawString( BASE_X2, BASE_Y1 + 75, lpzText, STRING_COLOR );

	const int BASE_Y2 = 215;
	sprintf_s( szBuff, "тł镐" );	lpzText = szBuff;
	DrawString( BASE_X1, BASE_Y2, lpzText, STRING_COLOR );
}
