//=============================================================================
// StoreListWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "StoreListWindow.h"
#include "PlayerParty.h"
#include "Item.h"
#include "Manipulator.h"
#include "StoreWindow.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CStoreListWindow::CStoreListWindow(void)
{
	CMenuWindow::m_nType = MENU_TYPE_VERTICAL;		// c^j[
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CStoreListWindow::~CStoreListWindow(void)
{
}

//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CStoreListWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CPlayerParty *pParty, CStoreWindow *pParent )
{
	BOOL bRet = CMenuWindow::Create( iPosX, iPosY, iWidth, iHeight );

	m_pParent = pParent;
	m_pPlayerParty = pParty;


	return bRet;
}

//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CStoreListWindow::FrameMove( const CManipulator *pMani )
{
	if ( !m_bFocused )
		return;

	int nLastCurPos = GetCurPos();
	CMenuWindow::FrameMove( pMani );

	// IʒuύX
	if ( nLastCurPos != GetCurPos() )
	{
		m_pParent->NotifyCurPosChange( this, GetCurPos() );
	}

	// LZL[
	if ( pMani->CheckKey( KEY_INPUT_Z ) )
	{
		m_pParent->NotifyCancelKey( this );
	}
	// L[
	else if ( pMani->CheckKey( KEY_INPUT_X ) )
	{
		if ( !m_bFocused )
			return;
		m_pParent->NotifyDecideKey( this, GetCurPos() );
	}
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CStoreListWindow::Render( void )
{
	if ( !IsVisible() )
		return;

	//CMenuWindow::Render();
	CFrameWindow::Render();

	char szBuff[64];

	// ACe`
	for ( int iCnt = 0; iCnt < (int)m_aryProductItem.size(); iCnt ++ )
	{
		CItem *pItem = m_aryProductItem.at( iCnt );
		if ( !pItem )
			continue;

		stMenuItem *pMenuItem = GetItem( iCnt );

		// O
		DrawString( m_nPosX + pMenuItem->nPosX, m_nPosY + pMenuItem->nPosY, pItem->szName, STRING_COLOR );

		// i
		sprintf_s( szBuff, sizeof(szBuff) , "%6d" , pItem->nValue );
		DrawString( m_nPosX + pMenuItem->nPosX + 120, m_nPosY + pMenuItem->nPosY, szBuff, STRING_COLOR );
	}


	// J[\`
	if ( m_bFocused  )
	{
		m_pCursor->Render();
	}
}
//-----------------------------------------------------------------------------
// SetProduct
//-----------------------------------------------------------------------------
void CStoreListWindow::SetProduct( std::vector<CItem *> &aryItem, int nRate )
{
	m_aryProductItem = aryItem;
	m_nRate = nRate;
	MakeDummyItem( m_aryProductItem.size() );
}
//-----------------------------------------------------------------------------
// MakeDummyItem
//-----------------------------------------------------------------------------
void CStoreListWindow::MakeDummyItem( int nCount )
{

	ClearMenuItem();

	// _~[ACeǉ
	const int BASE_POS_X  = 30;
	const int BASE_POS_Y  = 10;
	const int INCREMENT_Y = 15;

	for ( int iCnt = 0; iCnt < nCount; iCnt ++ )
	{
		stMenuItem Item;
		Item.nID = iCnt;
		Item.bEnabled = TRUE;

		// ʒu
		Item.nPosX = BASE_POS_X;
		Item.nPosY = INCREMENT_Y * iCnt + BASE_POS_Y;
		Item.lpzText = "ACe";
		Item.nIcon = 0;
		Item.nCount = 0;

		AddMenuItem( &Item );
	}
}
//-----------------------------------------------------------------------------
// GetSelectedItem
//-----------------------------------------------------------------------------
CItem *CStoreListWindow::GetSelectedItem( void )
{
	if ( m_nCursorIndex < 0 || (int)m_aryProductItem.size() <= m_nCursorIndex )
	{
		return NULL;
	}

	return m_aryProductItem.at( m_nCursorIndex );
}