//=============================================================================
// StorePartyWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "StorePartyWindow.h"
#include "PlayerParty.h"
#include "Item.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CStorePartyWindow::CStorePartyWindow(void)
	: m_nState( CCharacterObject::STATE_STAND )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CStorePartyWindow::~CStorePartyWindow(void)
{
}
//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CStorePartyWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CPlayerParty *pParty )
{
	BOOL bRet = CFrameWindow::Create( iPosX, iPosY, iWidth, iHeight );

	m_pPlayerParty = pParty;

	return bRet;
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CStorePartyWindow::FrameMove( void )
{
	CFrameWindow::FrameMove();

	m_nFrameCount ++;

	if ( m_nFrameCount % 40 < 20 )
	{
		m_nState = CPlayerBattle::STAND;
	}
	else
	{
		m_nState = CPlayerBattle::HANDS_UP;
	}
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CStorePartyWindow::Render( void )
{
	if ( !IsVisible() )
		return;

	CFrameWindow::Render();

	// LGʒu
	const POSITION PosPortrait[] = {
		{	5, 10 },
		{	5, 45 },
		{	5, 80 },
		{	5, 115 },
	};

	// p[eB`
	for ( int iCnt = 0; iCnt < m_pPlayerParty->GetPlayerCount(); iCnt ++ )
	{
		CPlayerChar *pPlayer = m_pPlayerParty->GetPlayer(iCnt);

		int nState = m_nState;
		if ( m_nMode == MODE_LIST )
		{
			nState = CPlayerBattle::STAND;
		}
		// LG
		if ( CEquipItem::CanEquip( m_pItem->nType, pPlayer->m_CharInfo.nJobID ) )
			m_pPlayerParty->RenderPortrait( iCnt, m_nPosX + PosPortrait[iCnt].nPosX, m_nPosY + PosPortrait[iCnt].nPosY, nState );		// O
		else
			m_pPlayerParty->RenderPortrait( iCnt, m_nPosX + PosPortrait[iCnt].nPosX + 20, m_nPosY + PosPortrait[iCnt].nPosY );	// 
	}
}
//-----------------------------------------------------------------------------
// SetTargetItem
//-----------------------------------------------------------------------------
void CStorePartyWindow::SetTargetItem( CItem *pItem )
{
	if ( !CEquipItem::IsEquipItem( pItem->nID ) )
	{
		if ( IsVisible() )
		{
			CSysError::Msg( "CStorePartyWindow::SetTargetItem łȂACeł" );
		}
		return;
	}

	m_pItem = (CEquipItem *)pItem;
}
