//=============================================================================
// StoreWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "StoreWindow.h"
#include "PlayerParty.h"
#include "DataManager.h"
#include "Item.h"
#include "Game.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CStoreWindow::CStoreWindow(void)
	: m_nType( STORE_TYPE_ITEM ), m_nMsgPtn( STORE_MSG_PATTERN_1 ), m_nFrameCount( 0 )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CStoreWindow::~CStoreWindow(void)
{
	RemoveAllStoreItems();
}

//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
BOOL CStoreWindow::Create( CPlayerParty *pPlayerParty )
{
	m_pPlayerParty = pPlayerParty;
	
	// uԂv\
	m_TagWnd.Create( 0, 0, 70, 28 );
	m_TagWnd.SetExtendBackGround( FALSE );
	m_lstCoWindow.push_back( &m_TagWnd );

	// bZ[W\
	m_MsgWnd.Create( 70, 0, 250, 28 );
	m_MsgWnd.SetExtendBackGround( FALSE );
	m_lstCoWindow.push_back( &m_MsgWnd );

	// wb_j[
	m_MenuWnd.Create( 0, 28, 160, 28, this );	// ʒm
	m_MenuWnd.SetExtendBackGround( FALSE );
	m_lstCoWindow.push_back( &m_MenuWnd );

	// M\
	m_GillWnd.Create( 160, 28, 160, 28 );
	m_GillWnd.SetExtendBackGround( FALSE );
	m_lstCoWindow.push_back( &m_GillWnd );

	// ACeXg()
	m_ListWnd.Create( 0, 56, 260, 145, pPlayerParty, this );
	m_ListWnd.SetExtendBackGround( FALSE );
	m_lstCoWindow.push_back( &m_ListWnd );

	// ACeXg()
	m_ItemWnd.Create( 0, 56, 320, 167, pPlayerParty, this );
	m_ItemWnd.SetExtendBackGround( FALSE );
	m_lstCoWindow.push_back( &m_ItemWnd );

	// p[eBEBhE
	m_PartyWnd.Create( 260, 56, 60, 155, pPlayerParty );
	m_PartyWnd.SetExtendBackGround( FALSE );
	m_lstCoWindow.push_back( &m_PartyWnd );

	// ʃEBhE
	m_AmountWnd.Create( 0, 56, 260, 100, pPlayerParty, this );
	m_AmountWnd.SetExtendBackGround( FALSE );
	m_lstCoWindow.push_back( &m_AmountWnd );

	// ڍ׃EBhE
	m_DescWnd.Create( 0, 156, 260, 45, this );
	m_DescWnd.SetExtendBackGround( FALSE );
	m_lstCoWindow.push_back( &m_DescWnd );

	// ʒuݒ
	ChangeFocus( &m_MenuWnd );
	m_MenuWnd.SetCurPos( 0 );

	return TRUE;
}
//-----------------------------------------------------------------------------
// XV
//-----------------------------------------------------------------------------
void CStoreWindow::FrameMove( const CManipulator *pMani )
{
	if ( !IsVisible() )
		return;

	if ( 0 < m_nFrameCount )
	{
		m_nFrameCount --;
		if ( m_nFrameCount == 0 )
		{	// iI

			// ݒ
			if ( m_MenuWnd.GetCurPos() == CStoreMenuWindow::MENU_ID_BUY )
			{
				// ʉʂ̖߂聨ACew
				if ( m_AmountWnd.IsVisible() )
				{
					// ACeǉ
					m_pPlayerParty->AddItem( m_AmountWnd.GetTargetItem()->nID, m_AmountWnd.GetCount() );
				}
				m_MsgWnd.SetMessage( GetBuyingMessage( m_nMsgPtn ) );
				m_ListWnd.SetVisible( TRUE );
				m_ListWnd.SetCurPos( m_ListWnd.GetCurPos() );
				ChangeFocus( &m_ListWnd );
			}
			else
			{
				// ʉʂ̖߂聨ACep
				if ( m_AmountWnd.IsVisible() )
				{
					// ACe炷
					m_pPlayerParty->RemoveItem( m_AmountWnd.GetTargetItem()->nID, m_AmountWnd.GetCount() );
				}
				m_MsgWnd.SetMessage( GetSellingMessage( m_nMsgPtn ) );
				m_ItemWnd.SetVisible( TRUE );
				m_ItemWnd.SetCurPos( m_ItemWnd.GetCurPos() );
				ChangeFocus( &m_ItemWnd );
			}
			m_AmountWnd.SetVisible( FALSE );
			m_DescWnd.SetVisible( FALSE );

		}
		return;
	}

	// ʓIȃj[
	CCoWndManager::FrameMove( pMani );
}
//-----------------------------------------------------------------------------
// `
//-----------------------------------------------------------------------------
void CStoreWindow::Render( void )
{
	if ( !IsVisible() )
		return;

	CCoWndManager::Render();

}
//-----------------------------------------------------------------------------
// 폜
//-----------------------------------------------------------------------------
void CStoreWindow::Delete( void )
{
	RemoveAllStoreItems();
}
//-----------------------------------------------------------------------------
// RemoveAllStoreItems
//-----------------------------------------------------------------------------
void CStoreWindow::RemoveAllStoreItems( void )
{
	for ( int iCnt = 0; iCnt < (int)m_aryItem.size(); iCnt ++ )
	{
		CItem *pItem = m_aryItem.at( iCnt );
		delete pItem;
	}

	m_aryItem.clear();
}
//-----------------------------------------------------------------------------
// SetStoreType
//-----------------------------------------------------------------------------
void CStoreWindow::SetStoreType( int nType, int nMsgPtn )
{
	m_nType = nType;
	m_nMsgPtn = nMsgPtn;
}
//-----------------------------------------------------------------------------
// SetStoreItem
//-----------------------------------------------------------------------------
void CStoreWindow::SetStoreItem( int nItemCount, int *pItemID, int nRate )
{
	m_nRate = nRate;
	RemoveAllStoreItems();

	for ( int iCnt = 0; iCnt < nItemCount; iCnt ++ )
	{
		CItem *pItem;
		CDataManager::GetInstance()->LoadOneItemData( pItemID[iCnt], &pItem );
		m_aryItem.push_back( pItem );
	}
}

//-----------------------------------------------------------------------------
// SetVisible
//-----------------------------------------------------------------------------
void CStoreWindow::SetVisible( BOOL bFlag )
{
	CCoWndManager::SetVisible( bFlag );

	if ( bFlag )
	{	// J[\ʒuݒ
		m_MenuWnd.SetFocus( TRUE );
		m_MenuWnd.SetCurPos( 0 );

		m_PartyWnd.SetVisible( FALSE );
		m_ItemWnd.SetVisible( FALSE );
		m_ListWnd.SetVisible( FALSE );
		m_AmountWnd.SetVisible( FALSE );
		m_DescWnd.SetVisible( FALSE );

		// 񂩐ݒ
		m_TagWnd.SetTagName( GetStoreNameTag( m_nType ) );

		// ݒ
		m_MsgWnd.SetMessage( GetIncomingMessage( m_nMsgPtn ) );

		m_nFrameCount = 0;
	}
}
//-----------------------------------------------------------------------------
// L[ʒm
//-----------------------------------------------------------------------------
void CStoreWindow::NotifyDecideKey( CFrameWindow *pWnd, int nMenuID )
{
	if ( pWnd == &m_MenuWnd )
	{
		switch ( nMenuID )
		{
		case CStoreMenuWindow::MENU_ID_BUY:			// 

			// ݒ
			m_MsgWnd.SetMessage( GetBuyingMessage( m_nMsgPtn ) );

			// iXgݒ
			m_ListWnd.SetProduct( m_aryItem, m_nRate );

			SetupPartyWnd( m_nType );

			m_ListWnd.SetVisible( TRUE );
			ChangeFocus( &m_ListWnd );
			m_ListWnd.SetCurPos( 0 );
			m_PartyWnd.SetMode( CStorePartyWindow::MODE_LIST );
			m_PartyWnd.SetTargetItem( m_aryItem.at(0) );
			break;

		case CStoreMenuWindow::MENU_ID_SELL:		// 

			// ݒ
			m_MsgWnd.SetMessage( GetSellingMessage( m_nMsgPtn ) );

			m_ItemWnd.SetVisible( TRUE );
			ChangeFocus( &m_ItemWnd );
			m_ItemWnd.SetCurPos( 0 );
			break;

		case CStoreMenuWindow::MENU_ID_EXIT:		// ł
			// n}ɖ߂
			CGame::GetInstance()->GetCursor()->SetVisible( FALSE );
			CGame::GetInstance()->SetMode( MODE_MAP );
			SetVisible( FALSE );
			break;
		}
	}
	else if ( pWnd == &m_ListWnd )
	{	// ACeIꂽ()
		CItem *pItem = m_ListWnd.GetSelectedItem();
		if ( !pItem )
			return;

		UINT nValue = (UINT)(pItem->nValue * ((double)m_nRate / 100.0 ));
		if ( m_pPlayerParty->GetGill() < nValue )
		{	// ܂
			m_MsgWnd.SetMessage( GetNotEnoughMessage( m_nMsgPtn ) );
			m_nFrameCount = 45;
			return;
		}

		m_ListWnd.SetVisible( FALSE );

		// ݒ
		m_MsgWnd.SetMessage( GetBuyingCountMessage( m_nMsgPtn ) );

		m_PartyWnd.SetMode( CStorePartyWindow::MODE_AMOUNT );
		m_AmountWnd.SetTargetItem( CStoreAmountWindow::MODE_BUY, pItem, m_nRate );
		m_AmountWnd.SetVisible( TRUE );
		m_DescWnd.SetTargetItem( pItem );
		m_DescWnd.SetVisible( TRUE );

		ChangeFocus( &m_AmountWnd );
	}
	else if ( pWnd == &m_ItemWnd )
	{	// ACeIꂽ()
		CItem *pItem = m_ItemWnd.GetSelectedItem();
		if ( !pItem )
			return;

		m_ItemWnd.SetVisible( FALSE );

		// ݒ
		m_MsgWnd.SetMessage( GetSellingCountMessage( m_nMsgPtn ) );

		m_AmountWnd.SetTargetItem( CStoreAmountWindow::MODE_SELL, pItem, m_nRate );
		m_AmountWnd.SetVisible( TRUE );
		m_DescWnd.SetTargetItem( pItem );
		m_DescWnd.SetVisible( TRUE );

		ChangeFocus( &m_AmountWnd );
	}
	else if ( pWnd == &m_AmountWnd )
	{	// 
		// ݒ
		m_MsgWnd.SetMessage( GetThankyouMessage( m_nMsgPtn ) );

		m_PartyWnd.SetMode( CStorePartyWindow::MODE_LIST );

		// 
		if ( m_AmountWnd.GetMode() == CStoreAmountWindow::MODE_BUY )
		{
			// 炷
			UINT nValue = (UINT)(m_AmountWnd.GetTargetItem()->nValue * ((double)m_nRate / 100.0 ));
			nValue *= m_AmountWnd.GetCount();
			m_pPlayerParty->SpendGill( nValue );
		}
		// 
		else
		{
			// 𑝂₷
			UINT nValue = (UINT)(m_AmountWnd.GetTargetItem()->nValue / 2 * ((double)m_nRate / 100.0 ));
			nValue *= m_AmountWnd.GetCount();
			m_pPlayerParty->AddGill( nValue );
		}

		// ʐ؂ւ܂ł̃t[ݒ
		m_nFrameCount = 45;
		return;
	}
}
//-----------------------------------------------------------------------------
// LZL[ʒm
//-----------------------------------------------------------------------------
void CStoreWindow::NotifyCancelKey( CFrameWindow *pWnd )
{
	if ( pWnd == &m_MenuWnd )
	{
		// n}ɖ߂
		CGame::GetInstance()->GetCursor()->SetVisible( FALSE );
		CGame::GetInstance()->SetMode( MODE_MAP );
		SetVisible( FALSE );
	}
	else if ( pWnd == &m_ListWnd )
	{
		// ݒ
		m_MsgWnd.SetMessage( GetIncomingMessage( m_nMsgPtn ) );

		m_PartyWnd.SetVisible( FALSE );
		m_ListWnd.SetVisible( FALSE );
		ChangeFocus( &m_MenuWnd );
		m_MenuWnd.SetCurPos( CStoreMenuWindow::MENU_ID_BUY );
	}
	else if ( pWnd == &m_AmountWnd )
	{
		m_PartyWnd.SetMode( CStorePartyWindow::MODE_LIST );
		m_AmountWnd.SetVisible( FALSE );
		m_DescWnd.SetVisible( FALSE );

		// ݒ
		if ( m_MenuWnd.GetCurPos() == CStoreMenuWindow::MENU_ID_BUY )
		{
			m_MsgWnd.SetMessage( GetBuyingMessage( m_nMsgPtn ) );
			m_ListWnd.SetVisible( TRUE );
			m_ListWnd.SetCurPos( m_ListWnd.GetCurPos() );
			ChangeFocus( &m_ListWnd );
		}
		else
		{
			m_MsgWnd.SetMessage( GetSellingMessage( m_nMsgPtn ) );
			m_ItemWnd.SetVisible( TRUE );
			m_ItemWnd.SetCurPos( m_ItemWnd.GetCurPos() );
			ChangeFocus( &m_ItemWnd );
		}

	}
	else if ( pWnd == &m_ItemWnd )
	{
		// ݒ
		m_MsgWnd.SetMessage( GetIncomingMessage( m_nMsgPtn ) );

		m_PartyWnd.SetVisible( FALSE );
		m_ItemWnd.SetVisible( FALSE );
		ChangeFocus( &m_MenuWnd );
		m_MenuWnd.SetCurPos( CStoreMenuWindow::MENU_ID_SELL );
	}
}
//-----------------------------------------------------------------------------
// qEBhẼJ[\ʒuύXʒm
//-----------------------------------------------------------------------------
void CStoreWindow::NotifyCurPosChange( CFrameWindow *pWnd, int nMenuID )
{
	if ( pWnd == &m_ListWnd )
	{
		CItem *pItem = m_ListWnd.GetSelectedItem();
		if ( pItem )
		{
			m_PartyWnd.SetTargetItem( pItem );
		}
	}
}
//-----------------------------------------------------------------------------
// ^Cvݒ
//-----------------------------------------------------------------------------
void CStoreWindow::SetupPartyWnd( int nType )
{

	if ( nType == STORE_TYPE_WEPON ||
		 nType == STORE_TYPE_ARMOR )
	{
		m_PartyWnd.SetVisible( TRUE );
	}
	else
	{
		m_PartyWnd.SetVisible( FALSE );
	}
}
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
const char *CStoreWindow::GetStoreNameTag( int nType ) const
{
	switch ( nType )
	{
	case STORE_TYPE_ITEM:
		return "ǂ";
	case STORE_TYPE_WEPON:
		return "Ԃ";
	case STORE_TYPE_ARMOR:
		return "ڂ";
	case STORE_TYPE_MAGIC:
		return "܂ق";
	}
	return "s";
}
//-----------------------------------------------------------------------------
// XbZ[W
//-----------------------------------------------------------------------------
const char *CStoreWindow::GetIncomingMessage( int nMsgPtn ) const
{
	switch ( nMsgPtn )
	{
	case STORE_MSG_PATTERN_1:
		return "uႢI@ǂȂ悤ŁHv";
	}
	return "p^[ݒ";
}
//-----------------------------------------------------------------------------
// bZ[W
//-----------------------------------------------------------------------------
const char *CStoreWindow::GetBuyingMessage( int nMsgPtn ) const
{
	switch ( nMsgPtn )
	{
	case STORE_MSG_PATTERN_1:
		return "uȂɂق񂾂Hv";
	}
	return "p^[ݒ";
}
const char *CStoreWindow::GetBuyingCountMessage( int nMsgPtn ) const
{
	switch ( nMsgPtn )
	{
	case STORE_MSG_PATTERN_1:
		return "uق񂾂Hv";
	}
	return "p^[ݒ";
}

//-----------------------------------------------------------------------------
// 鎞bZ[W
//-----------------------------------------------------------------------------
const char *CStoreWindow::GetSellingMessage( int nMsgPtn ) const
{
	switch ( nMsgPtn )
	{
	case STORE_MSG_PATTERN_1:
		return "uȂɂ񂾂Hv";
	}
	return "p^[ݒ";
}
const char *CStoreWindow::GetSellingCountMessage( int nMsgPtn ) const
{
	switch ( nMsgPtn )
	{
	case STORE_MSG_PATTERN_1:
		return "u񂾂Hv";
	}
	return "p^[ݒ";
}
//-----------------------------------------------------------------------------
// ȂbZ[W
//-----------------------------------------------------------------------------
const char *CStoreWindow::GetNotEnoughMessage( int nMsgPtn ) const
{
	switch ( nMsgPtn )
	{
	case STORE_MSG_PATTERN_1:
		return "uEEE˂@Ȃ悤ˁHv";
	}
	return "p^[ݒ";
}
//-----------------------------------------------------------------------------
// bZ[W
//-----------------------------------------------------------------------------
const char *CStoreWindow::GetThankyouMessage( int nMsgPtn ) const
{
	switch ( nMsgPtn )
	{
	case STORE_MSG_PATTERN_1:
		return "u܂ ǁ[Iv";
	}
	return "p^[ݒ";
}
