//=============================================================================
// StoreWindow.h
//=============================================================================
#pragma once
#include <assert.h>
#include <vector>
#include "cowndmanager.h"
#include "StoreMessageWindow.h"
#include "StoreMenuWindow.h"
#include "StoreGillWindow.h"
#include "StoreListWindow.h"
#include "StorePartyWindow.h"
#include "TagWindow.h"
#include "StoreAmountWindow.h"
#include "StoreDescWindow.h"
#include "StoreItemWindow.h"

class CPlayerParty;
class CItem;
//-----------------------------------------------------------------------------
// CStoreWindow
//-----------------------------------------------------------------------------
class CStoreWindow : public CCoWndManager
{
public:
	enum {
		STORE_TYPE_ITEM		= 1,	// 
		STORE_TYPE_WEPON	= 2,	// 퉮
		STORE_TYPE_ARMOR	= 3,	// h
		STORE_TYPE_MAGIC	= 4,	// @
	};

	enum {
		STORE_MSG_PATTERN_1	= 1,
		STORE_MSG_PATTERN_2	= 2,
		STORE_MSG_PATTERN_3	= 3,
		STORE_MSG_PATTERN_4	= 4,
	};

private:
	BOOL Create( void ){ assert(0); return FALSE;	};	// don't use

protected:

	int		m_nType;	// X^Cv
	int		m_nMsgPtn;	// bZ[Wp^[

	UINT	m_nFrameCount;

	// qEBhE
	CTagWindow			m_TagWnd;
	CStoreMenuWindow	m_MenuWnd;
	CStoreGillWindow	m_GillWnd;
	CStoreMessageWindow	m_MsgWnd;
	CStoreListWindow	m_ListWnd;
	CStoreItemWindow	m_ItemWnd;
	CStorePartyWindow	m_PartyWnd;
	CStoreAmountWindow	m_AmountWnd;
	CStoreDescWindow	m_DescWnd;


	// v[p[eB
	CPlayerParty		*m_pPlayerParty;

	// i
	std::vector<CItem *> m_aryItem;
	int					 m_nRate;

	// ێf[^폜
	void RemoveAllStoreItems( void );

	void SetupPartyWnd( int nType );

	// 擾
	const char *GetIncomingMessage( int nMsgPtn ) const;
	const char *GetBuyingMessage( int nMsgPtn ) const;
	const char *GetBuyingCountMessage( int nMsgPtn ) const;
	const char *GetSellingMessage( int nMsgPtn ) const;
	const char *GetSellingCountMessage( int nMsgPtn ) const;
	const char *GetThankyouMessage( int nMsgPtn ) const;
	const char *GetNotEnoughMessage( int nMsgPtn ) const;

	const char *GetStoreNameTag( int nType ) const;

public:
	CStoreWindow(void);
	virtual ~CStoreWindow(void);

	BOOL IsMenu( void ) const	// j[邩
	{	return TRUE;	};

	void SetVisible( BOOL bFlag );

	void SetMenuCursor( int nCursorPos )
	{	m_MenuWnd.SetCurPos( nCursorPos );	};

	// ^Cvƃp^[ݒ
	void SetStoreType( int nType, int nMsgPtn );
	// X̏iݒ
	void SetStoreItem( int nItemCount, int *pItemID, int nRate );
	
	BOOL Create( CPlayerParty *pPlayerParty );		// 
	void FrameMove( const CManipulator *pMani ); 	// XV
	void Render( void );		// `
	void Delete( void );		// j

	void HideFormationWindow( void );

	// qEBhẼj[ʒm
	void NotifyDecideKey( CFrameWindow *pWnd, int nMenuID );
	// qEBhẼLZ{^ʒm
	void NotifyCancelKey( CFrameWindow *pWnd );
	// qEBhẼJ[\ʒuύXʒm
	void NotifyCurPosChange( CFrameWindow *pWnd, int nMenuID );

	// j[ p[eBEBhEɃtH[JXڂΏۂIԏ
	void SelectPartyMemberReq( void );

};

