//=============================================================================
// SysError.cpp
//=============================================================================
#include "Stdinc.h"
#include "SysError.h"

void CSysError::Halt(const char *inputMsg,...) {
	int len;
	char buf[256];
	va_list ap;
	va_start(ap,inputMsg);
	len = vsprintf_s(buf,128,inputMsg,ap);
	va_end(ap);
	if(len!=EOF) {
		int EM = MessageBox(	GetMainWindowHandle(),
								buf,
								"ERROR",
								MB_OK|MB_ICONSTOP);
	}
	DxLib_End();
	exit(-1);
}
/* G[2iIȂj */
void CSysError::Msg(const char *inputMsg,...) {
	int len;
	char buf[1024];
	va_list ap;
	va_start(ap,inputMsg);
	len = vsprintf_s(buf,sizeof(buf),inputMsg,ap);
	va_end(ap);
	if(len!=EOF) {
		int EM = MessageBox(	GetMainWindowHandle(),
								buf,
								"ERROR",
								MB_OK|MB_ICONSTOP);
	}
}

// X^bN֐
void CSysDebug::printStack(lua_State *L) {

    // X^bN擾
    const int num = lua_gettop(L);
    if (num == 0) {
        printf("No stack.\n");
        return;
    }
    for (int i = num; i >= 1; i--) {
        printf("%03d(%04d): ", i, -num + i - 1);
        int type = lua_type(L, i);
        switch(type) {
        case LUA_TNIL:
            printf("NIL\n");
            break;
        case LUA_TBOOLEAN:
            printf("BOOLEAN %s\n", lua_toboolean(L, i) ? "true" : "false");
            break;
        case LUA_TLIGHTUSERDATA:
            printf("LIGHTUSERDATA\n");
            break;
        case LUA_TNUMBER:
            printf("NUMBER %f\n", lua_tonumber(L, i));
            break;
        case LUA_TSTRING:
            printf("STRING %s\n", lua_tostring(L, i));
            break;
        case LUA_TTABLE:
            printf("TABLE\n");
            break;
        case LUA_TFUNCTION:
            printf("FUNCTION\n");
            break;
        case LUA_TUSERDATA:
            printf("USERDATA\n");
            break;
        case LUA_TTHREAD:
            printf("THREAD\n");
            break;
        }
    }
    printf("-----------------------------\n\n");
}


//-----------------------------------------------------------------------------
// ReplaceString
//-----------------------------------------------------------------------------
void CUtil::ReplaceString( char *lpBuff, int nBuffLen, const char *lpzTgt, const char *lpzFind, const char *lpzReplace )
{
    int  i=0, max_a, max_b;
    RtlZeroMemory( lpBuff, nBuffLen );

    // ̍ő啶(p)𒲂ׂ
    max_a = strlen(lpzTgt);
    max_b = strlen(lpzFind);

    for( i = 0; i <= max_a; i++ ){
        if( !strncmp( &lpzTgt[i], lpzFind, max_b ) )
		{
            strcat_s( lpBuff, nBuffLen, lpzReplace );
            i += max_b-1;
        }
        else{
            strncat_s( lpBuff, nBuffLen, &lpzTgt[i], 1 );
        }
    }
}